/*
 * PanelDibujo.java
 *
 * Creado el 14 de mayo de 2006, 19:53
 */


package auxiliar;

/* Los siguientes paquetes se necesitan para usar el potencial grfico de JAVA */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/* Este paquete se necesita para hacer uso del objeto Vector */
import java.util.*;

/**
 * El objetivo de esta clase es disear una ventana en la que deseamos pintar
 * unos ejes coordenados y una lista de curvas planas con sus colores
 * respectivos. Cada curva estar representada por una familia finita de puntos,
 * y por "pintar la curva" se entiende conectar puntos consecutivos mediante
 * segmentos. Como no sabemos a priori cuntas curvas tenemos que pintar haremos
 * uso de dos objetos Vector, listaCurvas y listaColoresCurvas: cada componente
 * del Vector listaCurvas ser una curva (es decir, una matriz bidimensional nx2)
 * y la componente correspondiente del vector listaColoresCurvas el color (una
 * variable String) con el que la pintaremos.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class PanelDibujo extends JFrame {
    Vector listaCurvas = new Vector();
    Vector listaColoresCurvas = new Vector();
    
    /**
     * En las variables siguientes guardaremos las coordenadas  <xsi,ysi> 
     * del pixel situado en el extremo superior izquierdo de la ventana y 
     * las coordenadas <xid,yid> del pixel situado en el extremos inferior 
     * derecho de la ventana. Estas coordenadas por defecto podrn 
     * modificarse luego. Los  pixels se miden con dos coordenadas enteras 
     * que aumentan, respectivamente, segn nos desplazamos a la derecha 
     * y hacia abajo (no hacia arriba, como ocurre con las coordenadas usuales).
     * El pixel correspondiente al extremo superior izquierdo de la pantalla 
     * del ordenador es <0,0>.
     */    
    int xsi = 0;
    int ysi = 0;
    int xid = 800;
    int yid = 600;
    
    /**
     * Las variables siguientes nos dicen las dimensiones de los ejes 
     * coordenados que utilizaremos por defecto: de -5 a 5 para el eje x, 
     * de -4 a 4 para el eje y; elegiremos (0,0) como punto de cruce de ambos 
     * ejes, y fijaremos en 1 el tamao de la cuadrcula tanto en horizontal 
     * como en vertical. Al fijar ejescoordenados como false estamos diciendo 
     * que, salvo orden expresa, los ejes no se pintarn en la ventana.
     */    
    double eix = - 5;
    double esx = 5;
    double eiy = - 4;
    double esy = 4;
    double cx = 0;
    double cy = 0;
    double mx = 1;
    double my = 1;
    boolean ejescoordenados = false;
    
    /** 
     * El constructor de la clase PanelDibujo determina, por defecto, el 
     * ttulo de la ventana ("Dibujo de curvas en el plano"), las coordenadas 
     * del pixel situado en el extremo izquierdo superior de la vectana (<0,0>)
     * la anchura de la ventana (800) y la altura de la ventana (600). 
     * La instruccin show() hace que la ventana se abra cuando instanciamos 
     * desde nuestra aplicacin un objeto PanelDibujo.
     */    
    public PanelDibujo() {
        super("Dibujo de curvas en el plano");
        setBounds(0, 0, 800, 600);
        show();
    } //acaba el constructor de PanelDibujo
    
    /**
     * Esta sobrecarga del constructor de PanelDibujo nos permite elegir 
     * el ttulo de la ventana.
     */    
    public PanelDibujo(String etiqueta){
        super(etiqueta);
        setBounds(0, 0, 800, 600);
        show();
    } //acaba el constructor de PanelDibujo (primera sobrecarga)
    
    /**
     * Esta sobrecarga del constructor de PanelDibujo nos permite elegir el 
     * ttulo de la ventana y sus dimensiones.
     */    
    public PanelDibujo(String etiqueta, int xsupizda, int ysupizda, 
            int xinfdcha, int yinfdcha) {
        super(etiqueta);
        setBounds(xsupizda, ysupizda, xinfdcha - xsupizda, yinfdcha - ysupizda);
        xsi = xsupizda;
        ysi = ysupizda;
        xid = xinfdcha;
        yid = yinfdcha;
        show();
    } // acaba el constructor de PanelDibujo (segunda sobrecarga)
        
    /**
     * El mtodo addEjesCoordenados permite alterar el valor de la variable
     * ejescoordenados para que se puedan pintar los ejes.
     */    
    public void addEjesCoordenados(boolean dibuja){
        ejescoordenados = dibuja;
    } // acaba el mtodo addEjesCoordenados
    
    /**
     * Esta sobrecarga del mtodo addEjesCoordenados permite adems elegir los
     * extremos de los ejes.
     */    
    public void addEjesCoordenados(boolean dibuja, double extinfx, 
            double extsupx, double extinfy, double extsupy) {
        ejescoordenados = dibuja;
        eix = extinfx;
        esx = extsupx;
        eiy = extinfy;
        esy = extsupy;
        cx = (extinfx + extsupx) / 2;
        cy = (extinfy + extsupy) / 2;
        mx = (extsupx - extinfx) / 10;
        my = (extsupy - extinfy) / 8;
    } // acaba el mtodo addEjesCoordenados (primera sobrecarga)
    
    /**
     * Esta sobrecarga del mtodo addEjesCoordenados permite adems elegir 
     * el punto de cruce de los ejes.
     */    
    public void addEjesCoordenados(boolean dibuja, double extinfx, 
            double extsupx, double extinfy, double extsupy, double centrox, 
            double centroy ) {
        ejescoordenados = dibuja;
        eix = extinfx;
        esx = extsupx;
        eiy = extinfy;
        esy = extsupy;
        cx = centrox;
        cy = centroy;
        mx = (extsupx - extinfx) / 10;
        my = (extsupy - extinfy) / 8;
    } // acaba el mtodo addEjesCoordenados (segunda sobrecarga)
    
    /**
     * Esta sobrecarga del mtodo addEjesCoordenados permite adems elegir 
     * el tamao de la cuadrcula.
     */    
    public void addEjesCoordenados(boolean dibuja, double extinfx, 
            double extsupx, double extinfy, double extsupy, double centrox, 
            double centroy, double mallax, double mallay) {
        ejescoordenados = dibuja;
        eix = extinfx;
        esx = extsupx;
        eiy = extinfy;
        esy = extsupy;
        cx = centrox;
        cy = centroy;
        mx = mallax;
        my = mallay;
    } // acaba el mtodo addEjesCoordenados (tercera sobrecarga)
    
    /**
     * Los mtodos pixelx y pixely calculan el pixel que corresponde a un punto
     * de coordenadas (x,y). Recurdese que el pixel <0,0> corresponde a la 
     * esquina superior izquierda de la ventana, y que aumentan segn nos 
     * desplazamos a la derecha y hacia abajo.
     */    
    public int pixelx(double x) {
        return (int) Math.rint((xid - xsi) * (x - eix) / (esx - eix));
    } // acaba el mtodo pixelx
    
    public int pixely(double y){
        return (int) Math.rint((yid - ysi) * (esy - y) / (esy - eiy));
    } // acaba el mtod pixely
    
    /**
     * Un objeto Graphics es, por as decir, un "pincel" con el que se pueden 
     * dibujar cosas diversas. En el mtodo dibujaEjes usamos los siguientes 
     * mtodos asociados a este objeto:
     * 
     * setColor elige el color con el que vamos a pintar;
     * drawLine(p1, p2, q1, q2) dibuja la recta que conecta los pixels <p1,p2> y
     *    <q1,q2>;
     * drawString("xxx", p1, p2) situa la cadena de caracteres xxx en el pixel
     *    <p1,p2>.
     * El objetivo del mtodo dibujaEjes es dibujar unos ejes coordenados con el
     * objeto Graphics g a partir de la informacin recogida en 
     * addEjesCoordenados. Ntese que combinando Double.toString (transforma 
     * una variable Double en String) y Math.rint (que redondea un valor double 
     * al valor int ms cercano) conseguimos que los nmeros con los que 
     * etiquetamos los ejes tengan a lo sumo tres cifras decimales.
     */    
    public void dibujaEjes(Graphics g) {
        
        if (ejescoordenados == true) {
            g.setColor(Color.black);
            g.drawLine(pixelx(eix), pixely(cy), pixelx(esx), pixely(cy));
            g.drawLine(pixelx(cx), pixely(eiy), pixelx(cx), pixely(esy));
            for (int j = 1; cx + j * mx <= esx; j++) {
                g.drawLine(pixelx(cx + j * mx), pixely(cy) - 8,
                        pixelx(cx + j * mx), pixely(cy) + 8);
                g.drawString(Double.toString( 
                        Math.rint(1000 * (cx + j * mx)) / 1000),
                        pixelx(cx + j * mx), pixely(cy) + 24);
            }
            for (int j = - 1; cx + j * mx >= eix; j--) {
                g.drawLine(pixelx(cx + j * mx), pixely(cy) - 8,
                        pixelx(cx + j * mx), pixely(cy) + 8);
                g.drawString(Double.toString( 
                        Math.rint(1000 * (cx + j * mx)) / 1000),
                        pixelx(cx + j * mx), pixely(cy) + 24);
            }
            for (int j = 1; cy + j * my <= esy; j++) {
                g.drawLine(pixelx(cx) - 8, pixely(cy + j * my),
                        pixelx(cx) + 8, pixely(cy + j * my));
                g.drawString(Double.toString( 
                        Math.rint(1000 * (cy + j * my)) / 1000),
                        pixelx(cx) - 40, pixely(cy + j * my));
            }
            for (int j = - 1; cy + j * my >= eiy; j--) {
                g.drawLine(pixelx(cx) - 8, pixely(cy + j * my),
                        pixelx(cx) + 8, pixely(cy + j * my));
                g.drawString(Double.toString( 
                        Math.rint(1000 * (cy + j * my)) / 1000),
                        pixelx(cx) - 40, pixely(cy + j * my));
            }
        }
    } // acaba el mtodo dibujaEjes
    
    /**
     * El mtodo addCurva aade al Vector listaCurvas la familia de 
     * puntos xy[][] y al vector listaColoresCurvas el color que hemos 
     * elegido para pintar la poligonal que los conecta.
     */    
    public void addCurva(String color, double[][] xy) {
        int n = xy.length;
        double[][] xxyy = new double[n][2];
        
        for (int i = 0; i < n; i++) {
            xxyy[i][0] = xy[i][0];
            xxyy[i][1] = xy[i][1];
        }
        listaCurvas.add(xxyy);
        listaColoresCurvas.add(color);
    } // acaba el mtodo addCurva
    
    /**
     * Esta sobrecarga del mtodo addCurva calcula una malla de n puntos de la
     * grfica de la funcin f en el intervalo [extinf,extsup] y luego la aade 
     * al Vector listaCurvas (y al Vector listaColoresCurvas el color elegido).
     */    
    public void addCurva(String color, Funcion f, int n, double extinf, 
            double extsup) {
        double[][] xy = new double[n][2];
        
        listaColoresCurvas.add(color);        
        for(int i = 0; i < n; i++){
            xy[i][0] = extinf + i * (extsup - extinf) / (n - 1);
            xy[i][1] = f.eval(xy[i][0]);
        }
        listaCurvas.add(xy);
    } // acaba el mtodo addCurva (sobrecarga)
    
     /**
     * Esta sobrecarga del mtodo addCurva calcula una malla de n puntos de la
     * grfica del polinomio pol en el intervalo [extinf,extsup] y luego la aade 
     * al Vector listaCurvas (y al Vector listaColoresCurvas el color elegido).
     */    
    public void addCurva(String color, Polinomio pol, int n, 
            double extinf, double extsup) {
        double[][] xy = new double[n][2];
        
        listaColoresCurvas.add(color);        
        for(int i = 0; i < n; i++){
            xy[i][0] = extinf + i * (extsup - extinf) / (n - 1);
            xy[i][1] = pol.eval(xy[i][0]);
        }
        listaCurvas.add(xy);
    } // acaba el mtodo addCurva (sobrecarga)

    /**
     * Esta sobrecarga del mtodo addCurva pinta un punto de coordenadas (x, y).     
     */    
    public void addCurva(String color, double x, double y) {        
        double[][] xy = new double[2][2];
        
        listaColoresCurvas.add(color);        
        xy[0][0] = x;
        xy[0][1] = y;
        xy[1][0] = x;
        xy[1][1] = y;        
        listaCurvas.add(xy);
    } // acaba el mtodo addCurva (sobrecarga)    
    
    /**
     * Esta sobrecarga del mtodo addCurva pinta un punto "grueso" o "pequeo"
     * de coordenadas (x, y).     
     */    
    public void addCurva(String color, double x, double y, boolean grueso) {
        int n;
        double[][] xy;
        
        if (grueso) {
            n = 50;
            xy = new double[2 * n][2];
            listaColoresCurvas.add(color);        
            for (int i = 0; i < n; i++) {
                xy[2 * i][0] = x;  
                xy[2 * i][1] = y; 
                xy[2 * i + 1][0] = x + 3 * (esx - eix) / (xid - xsi) 
                        * Math.cos(2 * Math.PI * i / n);
                xy[2 * i + 1][1] = y + 3 * (esy - eiy) / (yid - ysi) 
                        * Math.sin(2 * Math.PI * i / n);        
            }
            listaCurvas.add(xy);
        } else {            
            xy = new double[2][2];
            listaColoresCurvas.add(color);        
            xy[0][0] = x;
            xy[0][1] = y;
            xy[1][0] = x;
            xy[1][1] = y;        
            listaCurvas.add(xy);
        }
    } // acaba el mtodo addCurva (sobrecarga)
    
    /**
     * El mtodo removeCurvas borra todos los elementos de listaCurvas y
     * listaColoresCurvas.
     */    
    public void removeCurvas() {
        listaCurvas.removeAllElements();
        listaColoresCurvas.removeAllElements();
    } // acaba el mtodo removeCurvas
    
    /**
     * El mtodo removeCurva borra los elementos n (es decir, los n+1-simos) 
     * de listaCurvas y listaColoresCurvas. No se hace uso de l en la 
     * aplicacin TestGraficos.
     */    
    public void removeCurva(int n){
        listaCurvas.remove(n);
        listaColoresCurvas.remove(n);
    } // acaba el mtodo removeCurva
    
    /**
     * El mtodo dibujaCurvas pinta con el objeto Graphics g las poligonales
     * correspondientes a las listas de puntos del Vector listaCurvas y con los
     * colores de listaColoresCurvas. Ntese la sintaxis precisa que permite 
     * extraer el contenido de los vectores para poder manipularlo.
     */
    public void dibujaCurvas(Graphics g) {
        double[][] xy;
        String color;
        int eleccion;
        
        for (int i = 0, n = listaCurvas.size(); i < n; i++) {
            xy = (double[][]) listaCurvas.elementAt(i);
            color = (String) listaColoresCurvas.elementAt(i);
            eleccion = 0;
            
            if (color == "negro") {
                eleccion = 1;
            } else if (color == "azul") {
                eleccion = 2;
            } else if (color == "rojo") {
                eleccion = 3;
            } else if (color == "verde") {
                eleccion = 4;
            } else if (color == "amarillo") {
                eleccion = 5;
            }
            switch (eleccion) {
                case 1:
                    g.setColor(Color.black);
                    break;
                case 2:
                    g.setColor(Color.blue);
                    break;
                case 3:
                    g.setColor(Color.red);
                    break;
                case 4:
                    g.setColor(Color.green);
                    break;
                case 5:
                    g.setColor(Color.yellow);
                    break;
                default:
                    System.out.println("Color incorrecto; " 
                            + "se usa por defecto el negro");
                    g.setColor(Color.black);
            }
            for (int j = 1; j < xy.length; j++) {
                g.drawLine(pixelx(xy[j-1][0]), pixely(xy[j-1][1]), 
                        pixelx(xy[j][0]), pixely(xy[j][1]));
            }
        }
    } // acaba el mtodo dibujaCurvas
    
    /**
     * Cada vez que el mtodo paint sea invocado (mediante repaint) desde la
     * aplicacin limpiar la ventana, pintar los ejes coordenados (salvo 
     * que la variable ejescoordenados tenga el valor false) y pintar todas 
     * las curvas almacenadas en listaCurvas con los colores de 
     * listaColoresCurvas.
     */    
    public void paint(Graphics g) {
        g.clearRect(0, 0, xid - xsi, yid - ysi);
        dibujaEjes(g);
        dibujaCurvas(g);        
    } // acaba el mtodo paint
    
} // acaba la clase PanelDibujo


