/*
 * EpsilonMaquina.java
 *
 * Creado el 29 de noviembre de 2005, 11:35
 */


package computacion.practica2;

/**
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class EpsilonMaquina {
    
    static double EPSILON = Math.pow(2, -53) + Math.pow(2, -105);
    
    public static void main(String[] args) {
        double epsilonAprox = 1;
        int k = 0;
        
        while (1+epsilonAprox > 1) {
            epsilonAprox = epsilonAprox / 2;
            k = k + 1;
        }
        epsilonAprox = 2 * epsilonAprox;
        k = k - 1;
        
        /**
         * El nmero epsilonAprox = Math.pow(2, k) = Math.pow(2, -52) es la 
         * potencia de dos ms pequea que sumada a 1 da un resultado mayor 
         * que 1. Sin embargo no es el psilon de la mquina (el nmero de
         * mquina ms pequeo que sumado a 1 da un resultado mayor que 1).
         * El verdadero psilon de la mquina es 
         *     EPSILON = Math.pow(2, -53) + Math.pow(2, -105)
         *              = Math.pow(2, -53) * (1 + Math.pow(2, -52)).
         * La razn es que Math.pow(2, -53) no sirve como psilon de la mquina
         * por ser 1 + Math.pow(2, -53) = 1, y EPSILON es el nmero de mquina
         * siguiente a Math.pow(2, -53) y verifica 1 + EPSILON > 1. Ntese que
         * mientras que Math.pow(2, -52) y EPSILON son distintos nmeros de 
         * mquina, 1 + Math.pow(2, -52) y 1 + EPSILON son exactamente el mismo 
         * nmero de mquina, 1 + Math.pow(2, -52), el inmediatamente 
         * posterior a 1.
         */     
        System.out.println("exponente = " + k);
        System.out.println("epsilon aproximado = " + epsilonAprox);
        System.out.println("Math.pow(2, -52) = " + Math.pow(2, -52));
        System.out.println("EPSILON = " + EPSILON);
        System.out.println("Math.pow(2, -53) = " + Math.pow(2, -53));        
        System.out.println("1 + Math.pow(2,-52) = " + (1 + Math.pow(2, -52)));        
        System.out.println("1 + EPSILON = " + (1 + EPSILON));
        System.out.println("1 + Math.pow(2,-53) = " +  (1 + Math.pow(2, -53)));
        System.out.println("EPSILON-Math.pow(2, -52) = "
                + (EPSILON - Math.pow(2, -52)));
        System.out.println("(1 + EPSILON)-(1 + Math.pow(2, -52)) = "
                + ((1 + EPSILON) - (1 + Math.pow(2,-52))));
    }
    
}
