/*
 * Ejercicio5.java
 *
 * Creado el 3 de abril de 2007, 20:56
 */


package ecuacionesPolinomicas.practica9;
import ORG.netlib.math.complex.Complex;
import auxiliar.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio5 {
    
    /**
     * Aqu resolvemos numricamente el ejercicio 20 de la hoja de problemas 4.
     * 
     * Si llamamos l a la distancia al suelo del punto de apoyo de la escalera 
     * que mide 30 metros en la pared izquierda del callejn, r a la distancia 
     * al suelo del punto de apoyo de la escalera que mide 20 metros en la 
     * pared derecha del callejn, x a la anchura total del callejn, y u,v
     * a las longitudes de los segmentos en que la proyeccin del punto de 
     * cruce de ambas escaleras divide al callejn, tendremos que
     *
     *   x^2 + l^2= 900, x^2 + r^2= 400,
     *   r / x = 8 / u, l / x = 8 / v.
     *
     * De aqu se obtiene para x la ecuacin 
     *
     *   1 / (900 - x^2)^{1/2} + 1 / (400 - x^2)^{1/2} = 1 / 8,
     *
     * y tras hacer operaciones llegamos al polinomio vemos que las races de
     * la ecuacin lo son tambin del polinomio
     *
     *   p(x) = [(900 - x^2)(400 - x^2) / 64 - (900 - x^2) - (400 - x^2)]^2
     *            - 4 (900 - x^2)(400 - x^2).
     * 
     * Ntese que no todas las races del polinomio lo son tambin de la 
     * ecuacin; de hecho, la solucin que buscamos es la nica de la 
     * ecuacin inicial que est entre 0 y 20 y la ecuacin polinomial tiene
     * dos soluciones reales entre 0 y 20.
     */
    public static void main(String[] args) {
       
        int nraizReal = 0;
        double[] raizReal = {0};
        double[][] intervalosSturm;
        double r, l, u, v, x;
        
        double[] coefa = {900, 0, - 1};
        double[] coefb = {400 ,0, - 1};
        Polinomio a = new Polinomio(coefa);
        Polinomio b = new Polinomio(coefb);
        Polinomio p = new Polinomio();
        Polinomio d = new Polinomio();
      
        /**
         * Calculamos el polinomio p =
         * [(900 - x^2)(400 - x^2) / 64 - (900 - x^2) - (400 - x^2)]^2
         *   - 4 (900 - x^2)(400 - x^2).
         */
        p = ( (a.producto(b).producto(1. / 64).resta(a.suma(b))).producto
                (a.producto(b).producto(1. / 64).resta(a.suma(b)))
                ).resta
                (a.producto(b.producto(4)));
        System.out.println("El polinomio cuyas races queremos encontrar es" 
                + " p = ");
        
        try {
            d = p;
            System.out.println();
            System.out.println("Bsqueda de races reales para p");
            intervalosSturm = p.bisecSturm(0.1);
            nraizReal = intervalosSturm.length;
            System.out.println("Total de races reales para p: " + nraizReal);
            System.out.println();
            raizReal = new double[nraizReal];
            for(int k = 0; k < nraizReal; k++) {
                System.out.println("Intervalo " + (k + 1) + ": ["
                        + intervalosSturm[k][0] + ", "
                        + intervalosSturm[k][1] + "]");
                raizReal[k] = intervalosSturm[k][0] + 0.5 *
                        (intervalosSturm[k][1] - intervalosSturm[k][0]);
                raizReal[k] = p.newton(raizReal[k], 0.5E-13, 500);
                System.out.println("Raz real " + (k + 1)
                + ": x_" + (k + 1) + " = " + raizReal[k]);
                System.out.println("Evaluacin de x_" + (k + 1)
                + ": p(x_" + (k + 1) + ") = "
                        + p.eval(raizReal[k]));
                d = d.deflacion(raizReal[k]);
                System.out.println("Deflacin " + (k + 1) + ": " + d);
            }
        } catch(Polinomio.ErrorPolinomios err) {
        }
        
        System.out.println();
        System.out.println("Comprobamos cul de las races obtenidas " 
                + "es solucin del problema original:");
        for (int k = 0; k < nraizReal; k++) {
            x = raizReal[k];
            l = Math.sqrt(900 - x * x);
            r = Math.sqrt(400 - x * x);
            u =  8 * x / r;
            v =  8 * x / l;
            System.out.println("Raz x = " + x);
            System.out.println("u + v = " + (u + v));
            System.out.println();
        }
        System.out.println("Por tanto la solucin correcta es x = " 
                + raizReal[2]);
                         
    }
    
    
}


