/*
 * PuntosAleatorios.java
 *
 * Creado el 2 de abril de 2007, 12:40
 */


package ecuacionesPolinomicas.practica9;

import auxiliar.*;

/* Los siguientes paquetes se necesitan para usar el potencial grfico de JAVA */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * El objetivo de esta aplicacin es usar un panel de dibujo (instanciando
 * un objeto de la clase PanelDibujoSimplificado) para pintar 
 * puntos de colores aleatorios.
 * 
 * @author Vctor Jimnez
 * 
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class PuntosAleatorios {
    
    public static void main(String args[]) {
        
        /**
         * Instanciamos el objeto pd de la clase PanelDibujo
         * y definimos unas variables 
         * auxiliares que necesitaremos en el programa. Durante la ejecucin 
         * de la aplicacin, tras instanciar pd, se abre inmediatamente en 
         * pantalla una ventana en la que iremos haciendo nuestros dibujos.
         */        
        PanelDibujoSimplificado pd = new PanelDibujoSimplificado(
                "Mapa de puntos de color aleatorio");
        
        /**
         * En este punto de la ejecucin de la aplicacin aparece una ventana 
         * vaca con el ttulo "Mapa de puntos de color aleatorio".
         */        
        double x;
        double y;        
        int rand;
        String[] colores = {"rojo", "azul", "verde"};
                
        /**
         * El mtodo addEjesCoordenados hace que la ventana "sepa" que deben 
         * pintarse unos ejes coordenados; con repaint se "da la orden" de que 
         * se pinten. El tiempo desde que aparece la ventana hasta que se 
         * pintan los ejes es prcticamente cero, por eso parece que la ventana
         * y los ejes aparecen a la vez.
         */                
        pd.addEjesCoordenados(true);
        pd.repaint();
                
        /**
         * La siguiente instruccin "enva" puntos de color aleatorio
         * a la ventana para que los almacene y pinte posteriormente.
         */  
        for (int i = 0; i < 800; i++) {
            x = - 5 + i / 80.;
            for (int j = 0; j < 640; j++) {
                rand = (int) (3 * Math.random());
                y = - 4 + j / 80.;                
                pd.addCurva(colores[rand], x, y);               
            }             
        }
        pd.repaint();
        
        /**
         * Finalmente enviamos una orden para que la ventana abierta se 
         * pueda cerrar correctamente y as detener la aplicacin.
         */        
        pd.addWindowListener(
                new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        }
        );
        
    } // acaba el metodo main de la aplicacin PuntosAleatorios       
    
} // acaba la aplicacin PuntosAleatorios


