/*
 * Ejercicio6.java
 *
 * Creado el 12 de diciembre de 2007, 10:43
 */


package metodosLineales.practica5;
import auxiliar.*;
import javax.swing.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio6 {
    
    public static void main(String[] args) {
        int n = 1;
        int m = 1;
        double[][] A;
        int[] indices;
        int aux;
        int cont;
        double prob;
        int sum = 0;
        double total = 100000;
        boolean datosErroneos;
        String auxString;
        
        /* Pedimos el nmero de filas de la matriz */
        datosErroneos = true;
        while (datosErroneos) {
            try {
                datosErroneos = false;
                auxString = JOptionPane.showInputDialog(
                        "Introduce el nmero de filas de la matriz ");
                n = Integer.parseInt(auxString);
                if (n <= 0) { // comprobamos que la cantidad sea adecuada
                    JOptionPane.showMessageDialog(null,
                            "Error: nmero entero pero no positivo");
                    datosErroneos = true;
                }
            } catch(Exception err) {
                datosErroneos = true;
                JOptionPane.showMessageDialog(null,
                        "Error: nmero no entero");
            }
        }

        /* Pedimos el nmero de columnas de la matriz */
        datosErroneos = true;
        while (datosErroneos) {
            try {
                datosErroneos = false;
                auxString = JOptionPane.showInputDialog(
                        "Introduce el nmero de columnas de la matriz ");
                m = Integer.parseInt(auxString);
                if (m <= 0) { // comprobamos que la cantidad sea adecuada
                    JOptionPane.showMessageDialog(null,
                            "Error: nmero entero pero no positivo");
                    datosErroneos = true;
                }
            } catch(Exception err) {
                datosErroneos = true;
                JOptionPane.showMessageDialog(null,
                        "Error: nmero no entero");
            }
        }        
        
        A = new double[n][m];
        indices = new int[n * m];
        
        try {
            for (int l = 1; l <= total; l++) {
                
                /**
                 * Para definir al azar una matriz con las condiciones pedidas
                 * renumeramos los coeficienes de la matriz de izquierda a 
                 * derecha y de arriba abajo. As, a A[0][0] le correspondera 
                 * el ndice ms bajo (el 0) y a A[n-1][m-1] el ms alto (nm-1).
                 * En general, a A[i][j] le corresponder el ndice im+j.
                 *
                 * Para seleccionar los n coeficiences de A a los que debemos 
                 * dar el valor 1 construimos un vector con todos los ndices
                 *   0, 1, 2,...,nm-1, 
                 * seleccionamos un ndice al azar de la lista, lo quitamos, 
                 * seleccionamos otro de la lista resultante y as 
                 * sucesivamente, hasta agotar las n elecciones. Al tiempo que
                 * hacemos esto, damos valor 1 a los coeficientes de la matriz
                 * A que llevan estos ndices asociados.
                 */
                for (int i = 0; i < n; i++) {
                    for(int j = 0; j < m; j++) {
                        A[i][j] = 0;
                    }
                }
                for (int k = 0; k < n * m; k++) {
                    indices[k] = k;
                }
                cont = n * m;
                for (int i = 0; i < n; i++) {
                    aux = indices[(int) (cont * Math.random())];
                    A[aux / m][aux - m *(aux / m)] = 1;
                    for (int j = aux; j < cont - 1; j++) {
                        indices[j] = indices[j + 1];
                    }
                    cont = cont - 1;
                }
                if(Matrices.independencia(A)) {
                    sum = sum + 1;
                }
                
            }
            
            System.out.println("Nmero de filas: " + n);
            System.out.println("Nmero de columnas: " + m);
            prob = sum / total;
            System.out.println("Proporcin de matrices con rango " + n + 
                    " entre las " + ((int) total) + " primeras: " + prob);
            System.out.println("Probabilidad de que una matriz tenga rango " + 
                    n + " = " + probabilidad(n, m));
        } catch(Matrices.ErrorMetodosLineales err) {
        }
        
        /* Esta instruccin final es necesaria cuando se usan ventanas */
        System.exit(0);
        
    }
    
    /**
     * La probabilidad de que una matriz n x m con exactamente n unos y el 
     * resto ceros tenga rango n, denotada por P(n,m), viene dada por 
     *   P(n,m) = V_n^m / C_n^{nm},
     * donde V_n^m denota las variaciones de m elementos tomados de n en n y 
     * C_n^{nm} denota las combinaciones de nm elementos tomadas de n en n. 
     * Por tanto 
     *  P(n,m) = [m!/(m-n)!] / [nm!/(n!(nm-n)!)]
     *         = [(n-1)(m-1)/(nm-1)][(n-2)(m-2)/(nm-2)][1(m-n+1)/(nm-n+1)].
     */
    public static double probabilidad(int n, int m) {
        double prob = 1;
        
        for (int i = 1; i < n; i++) {
            prob = prob * (m - i) * (n - i) / (n * m - i);
        }
        return prob;
    }
    
}
